
/**
 * @author isaac.fraile@i2cat.net
 */

/************************************************************************************
    SysClock, objecte rellotge.

    Utilitzat cada vegada que es vol definir un nou rellotge.
    Idealment s'inicialitza utilitzant un temps NTP.
************************************************************************************/

class SysClock {
    constructor( NTPData ) {
        this.delta = NTPData.minimalNTPLatencyDelta; //ms
        this.tickRate = 1000000;
        this.speed = 1.0;
        this.offset = 0; //ms
        this.precision = 1; //ms
        this.latency = NTPData.minimalNTPLatency; //ms
    }

    getTicks() {
        return ( Date.now() + this.offset - this.delta ) * this.tickRate;
    }

    getClockPrecision() {
        return this.precision;
    }
}

module.exports = SysClock;