
/**
 * @author isaac.fraile@i2cat.net
 */

/************************************************************************************
	CIIService, llibreria per gestionar el servei CII del protocol DVB-CSS
	Aquest servei s'encarrega de distribuir les URL dels diferents serveis disponibles
	i de informar cada vegada que es canvia el contingut que s'esta reproduint.
	La comunicació es fa utilitzant websockets TCP
************************************************************************************/

var CIIService = {

	SOCKET_LIST : [],

	ciiPromise : function(contentId) {

	    return new Promise((resolve, reject) => {

	    	var obj = {};
	    	
	    	obj.protocolVersion = 1.0;
	    	obj.wcUrl = 'udp://' + process.env.DEFAULT_ADDR + ':' + process.env.DEFAULT_WCPORT + '/wc';
	    	obj.tsUrl = 'ws://' + process.env.DEFAULT_ADDR + ':' + process.env.DEFAULT_WSPORT + '/dvbcssts';
	    	obj.private = [{}];
	    	obj.private[0].type = "tag:url";
	    	obj.private[0].contentSetterUrl = 'ws://' + process.env.DEFAULT_ADDR + ':' + process.env.DEFAULT_WSPORT + '/cs';
	    	obj.private[0].wsClockUrl = 'ws://' + process.env.DEFAULT_ADDR + ':' + process.env.DEFAULT_WSPORT + '/wc';
	    	obj.private[0].vrtServiceUrl = 'ws://' + process.env.DEFAULT_ADDR + ':' + process.env.DEFAULT_VRTPORT + '/';

	    	// OPTIONAL    	
	 		if ( contentId != undefined ) 
	 		{
	 			obj.contentId = contentId;  
	    		obj.contentIdStatus = "final";
	 		}

	        resolve( JSON.stringify( obj ) );
	    });
	},

	reset : function() {
		this.SOCKET_LIST = [];
	},

	sendToAll : function(contentId) {

		console.log('----> Send CII to all')
		this.ciiPromise( contentId ).then(( str ) => { 
			this.SOCKET_LIST.forEach( (e) => { e.send( str ) } );
		});
	},

	removeSocket : function(ws) {

		console.log('\x1b[31m->\x1b[0m Close CII connection') 
		this.SOCKET_LIST.forEach( (e, index) => {
			if ( e === ws ) this.SOCKET_LIST.splice( index, 1 );
		});
		console.log( '\x1b[32m->\x1b[0m CII connections: ' + this.SOCKET_LIST.length );
	},

	addSocket : function(ws, contentId) {

		this.ciiPromise( contentId ).then(( str ) => { 
			this.SOCKET_LIST.push( ws );
			console.log( '\x1b[32m->\x1b[0m CII connections: ' + this.SOCKET_LIST.length );
			ws.send( str ); 
		});
	}
}

module.exports = CIIService;