
/**
 * @author isaac.fraile@i2cat.net
 */

/************************************************************************************
    UDPServer, llibreria per gestionar les conexions WC del protocol DVB-CSS.

    Aquest servei s'encarrega de gestionar totes les conexion websocket UDP.

    Els serveis implementats son:
    * DVB-CSS-WC
************************************************************************************/

var server = require( 'dgram' ).createSocket( 'udp4' );
var WC = require( './protocol/wc' );

class UDPServer {
	constructor(clock) {

		server.bind( process.env.DEFAULT_WCPORT, process.env.DEFAULT_ADDR );

		server.on('listening', () => {
		    var address = server.address();
		    console.log('--> DVB-CSS UDP Server listening on ' + '\x1b[32m' +  address.address + ':' + address.port + '\x1b[0m');
		});

		server.on('message', (message, remote) => {

			WC.WCService.wcUDPPromise( message, clock.getTicks(), clock ).then(( str ) => { 
				server.send(str, 0, str.length, remote.port, remote.address, function(err, bytes) {
		            if ( err ) throw err;
		        });
			});
		});
	}
}

module.exports = UDPServer;